/************************************************************************/
/*      $Id: d70claifd.cpp,v 1.7 2005/12/29 17:29:26 joman Exp joman $  */
/*                                                                      */
/*      Source file name:   d70claifd.cpp                               */
/*                                                                      */
/************************************************************************/
/*      Revisions:                                                      */
/*                                                                      */
/*      Version 0.01 - Tue May 10 14:47:38 EDT 2005:                    */
/*              First coding.                                           */
/************************************************************************/
#ifdef WIN_GUI
#include "stdafx.h"
#endif

#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <string>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <list>

#include "d70config.h"
#include "d70revbyte.hpp"
#include "d70tif.hpp"
#include "d70claifd.hpp"
#include "d70inc2.h"

using namespace std;

unsigned long ulAFPoint = 0l;

string getAutoFocusData(string strString, unsigned long ulInput);

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
IFDElement& IFDElement::operator=(IFDElement &node)
{
	ifde.tag = node.ifde.tag;
	ifde.type = node.ifde.type;
	ifde.count = node.ifde.count;
	ifde.valofs = node.ifde.valofs;
	iIFDType = node.iIFDType;
	lAdjustedOffset = node.lAdjustedOffset;
	ulMakerNoteHeaderOffset = node.ulMakerNoteHeaderOffset;
	iFileType = node.iFileType;
	iImageType = node.iImageType;
	iASCILabelSkipLength = node.iASCILabelSkipLength;
	isWantedValue = node.isWantedValue;
	programName = node.programName;
	programVersion = node.programVersion;
	programDate = node.programDate;
	fileName = node.fileName;
	stringData = node.stringData;
	rawData = node.rawData;
	displayStringData = node.displayStringData;

	return *this;
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
bool IFDElement::operator==(IFDElement &node)
{
	bool bEqual = true;

	if(getTag() != node.getTag())
	{
		bEqual = false;
		return bEqual;
	}

/*
	if(memcmp(&ifde, &node.ifde, sizeof(IFDENTRY)))
	{
		bEqual = false;
		return bEqual;
	}

	if(iIFDType != node.iIFDType)
	{
		bEqual = false;
		return bEqual;
	}

	if(lAdjustedOffset != node.lAdjustedOffset)
	{
		bEqual = false;
		return bEqual;
	}

	if(isWantedValue != node.isWantedValue)
	{
		bEqual = false;
		return bEqual;
	}

	if(programName != node.programName)
	{
		bEqual = false;
		return bEqual;
	}

	if(programVersion != node.programVersion)
	{
		bEqual = false;
		return bEqual;
	}

	if(programDate != node.programDate)
	{
		bEqual = false;
		return bEqual;
	}

	if(fileName != node.fileName)
	{
		bEqual = false;
		return bEqual;
	}

	if(stringData != node.stringData)
	{
		bEqual = false;
		return bEqual;
	}

	if(displayStringData != node.displayStringData)
	{
		bEqual = false;
		return bEqual;
	}
*/
	return bEqual;
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
void IFDElement::setData(FILE *rfd)
{
	int ctr1 = 0;
	static string strLocalString;
	long position = 0l;
	char buffer[128];
	unsigned long numirator = 0l;
	unsigned long denominator = 0l;
	unsigned long numirator_cnvtd = 0l;
	unsigned long denominator_cnvtd = 0l;
	long snumirator = 0l;
	long sdenominator = 0l;
	long snumirator_cnvtd = 0l;
	long sdenominator_cnvtd = 0l;

	position = ftell(rfd);

#ifdef JON
	//cout << "\n+setData";
	//cout << "\nExposureBracketValue (0x19) Raw      : " << getDataValueRaw(0x19, true);
	//cout << "\nExposureBracketValue (0x19) Converted: " << getDataValue(0x19, true);
#endif  //JON

	if((getIFDType() == itMakerNotes) || (getIFDType() == itThumbIFD))
		setAdjustedOffset(getMakerNoteHdrOffset());
	else
	{
		if(getFileType())
			setAdjustedOffset(0);
		else
			setAdjustedOffset(getFileTypeOffset());
	}

	if(TiffDataTypeSize(getType()) * getCount() > 4)
	{
		string strLocalString2;
		strLocalString2.resize(TiffDataTypeSize(getType()) * getCount());
		fseek( rfd, getAdjustedOffset() + getOffset(), SEEK_SET );
		fread((void *) strLocalString2.c_str(), TiffDataTypeSize(getType()) * getCount(), 1, rfd);
		setRawData(strLocalString2);
	}

	strLocalString.resize(0);

	switch(getType())
	{

/*
enum TiffDataTypes
{
    tNone,          // unspecified
    tUByte,         // 8-bit unsigned
    tAscii,         // Null terminated string
    tUShort,        // 16-bit unsigned
    tULong,         // 32-bit unsigned
    tURational,     // 32-bit unsigned x 2
    tSByte,         // 8-bit signed
    tByte,          // 8-bit undefined
    tSShort,        // 16-bit signed
    tSLong,         // 32-bit signed
    tSRational,     // 32-bit signed x 2
    tFloat,         // 4-byte IEEE
    tDouble         // 8-byte IEEE
};
*/

		case tUByte:	// 1

			if(getCount() > 4)
			{
				strLocalString.resize(getCount() + 1);
				fseek( rfd, getAdjustedOffset() + getOffset(), SEEK_SET );
				fread((void *) strLocalString.c_str(), getCount(), 1, rfd);
				fseek( rfd, position, SEEK_SET );
				setIsLessThanFourBytes(false);
			}
			else
			{
				setIsLessThanFourBytes(true);
				strLocalString = getTypeOneLessThan4Value();
			}
			break;
		case tAscii:	// 2

			if(getCount() > 4)
			{
				string strTempString;
				int iPos = 0;

                // must remove the terminating NULL character, so subtract one:
                strTempString.resize(getCount() - 1);
                fseek( rfd, getAdjustedOffset() + getOffset(), SEEK_SET );
                fread((void *) strTempString.c_str(), getCount() - 1, 1, rfd);

				iPos = strTempString.find_first_of('\0', 0);

				if(iPos != -1)
					strTempString.resize(iPos);

				strLocalString.resize(0);
				strLocalString.append(strTempString);
#ifdef JON
                //cout << "\nstrLocalString: " << strLocalString;
                //cout << "\nstrLocalString.length: " << strLocalString.length();
                //cout << "\ngetCount: " << getCount();
#endif  //JON
                fseek( rfd, position, SEEK_SET );
                setIsLessThanFourBytes(false);
			}
			else
			{
				setIsLessThanFourBytes(true);
				strLocalString = getTypeTwoLessThan4Value();
			}

			break;
		case tUShort:		// 3

			if((2 * getCount()) > 4)
			{
				unsigned short usNumber = 0;

				fseek( rfd, getAdjustedOffset() + getOffset(), SEEK_SET );

				for(int ctr1 = 0; ctr1 < getCount(); ctr1++)
				{
					char buffer[32];
					fread(&usNumber, sizeof(unsigned short), 1, rfd);

					if( ReverseByteOrder() )
						usNumber = rev_word( usNumber );

					sprintf(buffer, "%d ", usNumber);
					strLocalString.append(string(buffer));
				}

				fseek( rfd, position, SEEK_SET );
				setIsLessThanFourBytes(false);
			}
			else
			{
				setIsLessThanFourBytes(true);
				strLocalString = getTypeThreeLessThan4Value();
			}
			break;
		case tULong:	// 4

			if((4 * getCount()) > 4)
			{
				unsigned long ulNumber = 0l;
				unsigned long ulCount = getCount();

				if(ulCount > 40)	//JON JON JON
					ulCount = 40;

				fseek( rfd, getAdjustedOffset() + getOffset(), SEEK_SET );

				for(int ctr1 = 0; ctr1 < ulCount; ctr1++)
				{
					char buffer[32];
					fread(&ulNumber, sizeof(unsigned long), 1, rfd);
					sprintf(buffer, "0x%x ", Get32u(&ulNumber));
					strLocalString.append(string(buffer));
				}

				fseek( rfd, position, SEEK_SET );
				setIsLessThanFourBytes(false);
			}
			else
			{
				setIsLessThanFourBytes(true);
				strLocalString = getTypeFourLessThan4Value();
			}
			break;
		case tURational:	// 5
			memset(buffer, (int) '\0', 128);

			fseek( rfd, getAdjustedOffset() + getOffset(), SEEK_SET );

			for(ctr1 = 0; ctr1 < getCount(); ctr1++)
			{
				fread(&numirator, sizeof(unsigned long), 1, rfd);
				fread(&denominator, sizeof(unsigned long), 1, rfd);
				numirator_cnvtd = Get32s(&numirator);
				denominator_cnvtd = Get32s(&denominator);
				sprintf(buffer, "%f ", (float) numirator_cnvtd/(float) denominator_cnvtd); 
				strLocalString.append(string(buffer));
			}

			fseek( rfd, position, SEEK_SET );
			setIsLessThanFourBytes(false);
			break;
		case tSByte:	// 6

			if(getCount() > 4)
			{
				strLocalString.resize(getCount() + 1);
				fseek( rfd, getAdjustedOffset() + getOffset(), SEEK_SET );
				fread((void *) strLocalString.c_str(), getCount(), 1, rfd);
				fseek( rfd, position, SEEK_SET );
				setIsLessThanFourBytes(false);
			}
			else
			{
				setIsLessThanFourBytes(true);
				strLocalString = getTypeSixLessThan4Value();
			}
			break;
		case tByte:	// 7
			strLocalString = processTypeSeven(rfd);
			break;
		case tSShort:		// 8

			if((2 * getCount()) > 4)
			{
				unsigned short usNumber = 0;

				fseek( rfd, getAdjustedOffset() + getOffset(), SEEK_SET );

				for(int ctr1 = 0; ctr1 < getCount(); ctr1++)
				{
					char buffer[32];
					fread(&usNumber, sizeof(unsigned short), 1, rfd);

					if( ReverseByteOrder() )
						usNumber = rev_word( usNumber );

					sprintf(buffer, "%d ", usNumber);
					strLocalString.append(string(buffer));
				}

				fseek( rfd, position, SEEK_SET );
				setIsLessThanFourBytes(false);
			}
			else
			{
				setIsLessThanFourBytes(true);
				strLocalString = getTypeEightLessThan4Value();
			}
			break;
		case tSRational:	// 10
			memset(buffer, (int) '\0', 128);

			fseek( rfd, getAdjustedOffset() + getOffset(), SEEK_SET );

			for(ctr1 = 0; ctr1 < getCount(); ctr1++)
			{
				fread(&snumirator, sizeof(unsigned long), 1, rfd);
				fread(&sdenominator, sizeof(unsigned long), 1, rfd);
				snumirator_cnvtd = Get32s(&snumirator);
				sdenominator_cnvtd = Get32s(&sdenominator);
				sprintf(buffer, "%f ", (float) snumirator_cnvtd/(float) sdenominator_cnvtd); 
				strLocalString.append(string(buffer));
			}

			fseek( rfd, position, SEEK_SET );
			setIsLessThanFourBytes(false);
			break;
		default:
			break;
	}

	setStringData(strLocalString);
	setDisplayData(strLocalString);

#ifdef JON
	//cout << "\nstrLocalString: " << strLocalString;

	//cout << "\nExposureBracketValue (0x19) Raw      : " << getDataValueRaw(0x19, true);
	//cout << "\nExposureBracketValue (0x19) Converted: " << getDataValue(0x19, true);

	//cout << "\nsetData Start";
	//list();
	//cout << "\nsetData End";
	//cout << "\n-setData";
#endif  //JON

	fseek( rfd, position, SEEK_SET );
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
string& IFDElement::setDisplayData(const string& strString)
{
	static string strLocalString;
	char buffer[256];
	int iValue = 0;

	strLocalString.resize(0);

	switch(getTag())
	{
		case 0xfffb:	//LensID
			if(!strString.compare(string("2"))) 
				strLocalString.append("Unknown Nikkor or Sigma non D-type");
			else if(!strString.compare(string("7"))) 
				strLocalString.append("Nikkor AF 28-85/3.5-4.5");
			else if(!strString.compare(string("8"))) 
				strLocalString.append("Nikkor AF 35-105/3.5-4.5");
			else if(!strString.compare(string("9"))) 
				strLocalString.append("Nikkor AF 24/2.8");
			else if(!strString.compare(string("11"))) 
				strLocalString.append("Nikkor AF 180/2.8 IF-ED");
			else if(!strString.compare(string("15"))) 
				strLocalString.append("Nikkor AF 50/1.8");
			else if(!strString.compare(string("16"))) 
				strLocalString.append("Nikkor AF 300/4 IF-ED");
			else if(!strString.compare(string("19"))) 
				strLocalString.append("Nikkor AF 24-50/3.3-4.5");
			else if(!strString.compare(string("20"))) 
				strLocalString.append("Nikkor AF 80-200/2.8 ED");
			else if(!strString.compare(string("27"))) 
				strLocalString.append("Nikkor AF 75-300/4.5-5.6");
			else if(!strString.compare(string("28")))  
				strLocalString.append("Nikkor AF 20/2.8");
			else if(!strString.compare(string("29")))  
				strLocalString.append("Nikkor AF 35-70/3.3-4.5 N");
			else if(!strString.compare(string("30")))  
				strLocalString.append("Nikkor AF 60/2.8 Micro");
			else if(!strString.compare(string("34")))  
				strLocalString.append("Nikkor AF 70-210/4-5.6 D");
			else if(!strString.compare(string("38")))  
				strLocalString.append("Unkown Nikkor or Sigma D-type");
			else if(!strString.compare(string("42")))  
				strLocalString.append("Nikkor AF 28/1.4 D");
			else if(!strString.compare(string("44")))  
				strLocalString.append("Nikkor AF 105/2 D DC-Nikkor");
			else if(!strString.compare(string("45")))  
				strLocalString.append("Nikkor AF 200/4 D IF-ED Micro");
			else if(!strString.compare(string("47")))  
				strLocalString.append("Nikkor AF 28-70/3.5-4.5 D");
			else if(!strString.compare(string("47")))  
				strLocalString.append("Nikkor AF 20-35/2.8 D IF");
			else if(!strString.compare(string("49")))  
				strLocalString.append("Nikkor AF 60/2.8 D Micro");
			else if(!strString.compare(string("50")))  
				strLocalString.append("Nikkor AF 105/2.8 D Micro");
			else if(!strString.compare(string("51")))  
				strLocalString.append("Nikkor AF 18/2.8 D");
			else if(!strString.compare(string("52")))  
				strLocalString.append("Unknown Nikkor or Tameron");
			else if(!strString.compare(string("54")))  
				strLocalString.append("Nikkor AF 24/2.8 D");
			else if(!strString.compare(string("55")))  
				strLocalString.append("Nikkor AF 20/2.8 D");
			else if(!strString.compare(string("56")))  
				strLocalString.append("Nikkor AF 85/1.8 D");
			else if(!strString.compare(string("59")))  
				strLocalString.append("Nikkor AF 35-70/2.8 D");
			else if(!strString.compare(string("66")))  
				strLocalString.append("Nikkor AF 35/2 D");
			else if(!strString.compare(string("67")))  
				strLocalString.append("Nikkor AF 50/1.4 D");
			else if(!strString.compare(string("69")))  
				strLocalString.append("Nikkor AF 35-80/4-5.6 D");
			else if(!strString.compare(string("72")))  
				strLocalString.append("Nikkor AF-S 300/2.8 D IF-ED");
			else if(!strString.compare(string("74")))  
				strLocalString.append("Nikkor AF 85/1.4 D IF");
			else if(!strString.compare(string("76")))  
				strLocalString.append("Nikkor AF 24-120/3.5-5.6 D IF");
			else if(!strString.compare(string("77")))  
				strLocalString.append("Nikkor AF 28-200/3.5-5.6 D IF");
			else if(!strString.compare(string("78")))  
				strLocalString.append("Nikkor AF 135/2 D DC-Nikkor");
			else if(!strString.compare(string("83")))  
				strLocalString.append("Nikkor AF 80-200/2.8 D ED N");
			else if(!strString.compare(string("84")))  
				strLocalString.append("Nikkor AF 70-180/4.5-5.6 D ED Micro");
			else if(!strString.compare(string("86")))  
				strLocalString.append("Nikkor AF 70-300/4-5.6 D ED");
			else if(!strString.compare(string("93")))  
				strLocalString.append("Nikkor AF-S 28-70/2.8 D IF-ED");
			else if(!strString.compare(string("94")))  
				strLocalString.append("Nikkor AF-S 80-200/2.8 D IF-ED");
			else if(!strString.compare(string("99")))  
				strLocalString.append("Nikkor AF-S 17-35/2.8 D IF-ED");
			else if(!strString.compare(string("101")))  
				strLocalString.append("Nikkor AF 80-400/4.5-5.6 D ED VR");
			else if(!strString.compare(string("102")))  
				strLocalString.append("Nikkor AF 18-35/3.5-4.5 D IF-ED");
			else if(!strString.compare(string("103")))  
				strLocalString.append("Nikkor AF 24-85/2.8-4 D IF");
			else if(!strString.compare(string("104")))  
				strLocalString.append("Nikkor AF 28-80/3.3-5.6 G");
			else if(!strString.compare(string("105")))  
				strLocalString.append("Nikkor AF 70-300/4-5.6 G");
			else if(!strString.compare(string("106")))  
				strLocalString.append("Nikkor AF-S 300/4 D IF-ED");
			else if(!strString.compare(string("109")))  
				strLocalString.append("Nikkor AF-S 300/2.8 D IF-ED II");
			else if(!strString.compare(string("110")))  
				strLocalString.append("Nikkor AF-S 400/2.8 D IF-ED II");
			else if(!strString.compare(string("112")))  
				strLocalString.append("Nikkor AF-S 600/4 D IF-ED");
			else if(!strString.compare(string("114")))  
				strLocalString.append("Nikkor 45mm F/2.8");
			else if(!strString.compare(string("116")))  
				strLocalString.append("Nikkor AF-S 24-85/3.5-4.5 G IF-ED");
			else if(!strString.compare(string("118")))  
				strLocalString.append("Nikkor AF 50/1.8 D");
			else if(!strString.compare(string("119")))  
				strLocalString.append("Nikkor AF-S 70-200/2.8 G IF-ED VR");
			else if(!strString.compare(string("120")))  
				strLocalString.append("Nikkor AF-S 24-120/3.5-5.6 G IF-ED VR");
			else if(!strString.compare(string("121")))  
				strLocalString.append("Nikkor AF 28-200/3.5-5.6 G IF-ED");
			else if(!strString.compare(string("122")))  
				strLocalString.append("Nikkor AF-S 12-24/4 G IF-ED DX");
			else if(!strString.compare(string("123")))  
				strLocalString.append("Nikkor AF-S 200-400/4 G IF-ED VR");
			else if(!strString.compare(string("125")))  
				strLocalString.append("Nikkor AF-S 17-55/2.8 G IF-ED DX");
			else if(!strString.compare(string("127")))  
				strLocalString.append("Nikkor AF-S 18-70/3.5-4.5 G IF-ED DX");
			else if(!strString.compare(string("128")))  
				strLocalString.append("Nikkor AF 10.5/2.8 G ED DX Fisheye");
			else if(!strString.compare(string("129")))  
				strLocalString.append("Nikkor AF-S 200/2 G IF-ED VR");
			else if(!strString.compare(string("130")))  
				strLocalString.append("Nikkor AF-S 300/2.8 G IF-ED VR");
			else if(!strString.compare(string("137")))  
				strLocalString.append("Nikkor 55-200mm F/4-5.6G");
			else if(!strString.compare(string("139")))  
				strLocalString.append("Nikkor 18-200 mm f/3.5-5.6 G-VR");
			else if(!strString.compare(string("140")))  
				strLocalString.append("Nikkor 18-55mm F/3.5-5.6G");
			else if(!strString.compare(string("Unknown")))  
				strLocalString.append("Unknown Nikkor or Non-Nikkor Lens");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x0201:	//ThumbnailOffset
		case 0x0111:	//StripOffsets
		case 0x0011:	//ThumbnailImageIFDOffset
		case 0x8769:	//ExifOffset
		case 0x927c:	//MakerNoteOffset
		case 0xa005:	//InteroperabilityOffset
			iValue = atoi(strString.c_str());
			sprintf(buffer, "%d(0x%04x)", iValue, iValue);
			strLocalString.append(buffer);
			break;
		case 0x829a:		//ExposureTime
			if(atof(strString.c_str()) <= 0.5)
				sprintf(buffer, "1/%d", (int) (0.5 + 1/atof(strString.c_str())));
			else
				sprintf(buffer, "%6.4f", (double) atof(strString.c_str()));

			strLocalString.append(buffer);
			strLocalString.append(" seconds");
			break;
		case 0x9208:	//LightSource
			if(!strString.compare(string("1")))
				strLocalString.append("Daylight");
			else if(!strString.compare(string("2")))
				strLocalString.append("Fluorescent");
			else if(!strString.compare(string("3")))
				strLocalString.append("Tungsten");
			else if(!strString.compare(string("4")))
				strLocalString.append("Flash");
			else if(!strString.compare(string("9")))
				strLocalString.append("Fine Weather");
			else if(!strString.compare(string("10")))
				strLocalString.append("Cloudy");
			else if(!strString.compare(string("11")))
				strLocalString.append("Shade");
			else if(!strString.compare(string("12")))
				strLocalString.append("Daylight Fluorescent");
			else if(!strString.compare(string("13")))
				strLocalString.append("Day White Fluorescent");
			else if(!strString.compare(string("14")))
				strLocalString.append("Cool White Fluorescent");
			else if(!strString.compare(string("15")))
				strLocalString.append("White Fluorescent");
			else if(!strString.compare(string("17")))
				strLocalString.append("Standard Light A");
			else if(!strString.compare(string("18")))
				strLocalString.append("Standard Light B");
			else if(!strString.compare(string("19")))
				strLocalString.append("Standard Light C");
			else if(!strString.compare(string("20")))
				strLocalString.append("D55");
			else if(!strString.compare(string("21")))
				strLocalString.append("D65");
			else if(!strString.compare(string("22")))
				strLocalString.append("D75");
			else if(!strString.compare(string("23")))
				strLocalString.append("D50");
			else if(!strString.compare(string("24")))
				strLocalString.append("ISO Studio Tungsten");
			else if(!strString.compare(string("255")))
				strLocalString.append("Other");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x9209:	//Flash
			if(!strString.compare(string("0")))
				strLocalString.append("No Flash");
			else if(!strString.compare(string("1")))
				strLocalString.append("Fired");
			else if(!strString.compare(string("5")))
				strLocalString.append("Fired, Return not detected");
			else if(!strString.compare(string("7")))
				strLocalString.append("Fired, Return detected");
			else if(!strString.compare(string("9")))
				strLocalString.append("On");
			else if(!strString.compare(string("13")))
				strLocalString.append("On, Return not detected");
			else if(!strString.compare(string("15")))
				strLocalString.append("On, Return detected");
			else if(!strString.compare(string("16")))
				strLocalString.append("Off");
			else if(!strString.compare(string("24")))
				strLocalString.append("Auto, Did not fire");
			else if(!strString.compare(string("25")))
				strLocalString.append("Auto, Fired");
			else if(!strString.compare(string("29")))
				strLocalString.append("Auto, Fired, Return not detected");
			else if(!strString.compare(string("31")))
				strLocalString.append("Auto, Fired, Return detected");
			else if(!strString.compare(string("32")))
				strLocalString.append("No flash function");
			else if(!strString.compare(string("65")))
				strLocalString.append("Fired, Red-eye reduction");
			else if(!strString.compare(string("69")))
				strLocalString.append("Fired, Red-eye reduction, Return not detected");
			else if(!strString.compare(string("71")))
				strLocalString.append("Fired, Fired, Red-eye reduction, Return detected");
			else if(!strString.compare(string("73")))
				strLocalString.append("On, Red-eye reduction");
			else if(!strString.compare(string("77")))
				strLocalString.append("On, Red-eye reduction, Return not detected");
			else if(!strString.compare(string("79")))
				strLocalString.append("On, Red-eye reduction, Return detected");
			else if(!strString.compare(string("89")))
				strLocalString.append("Auto, Fired, Red-eye reduction");
			else if(!strString.compare(string("93")))
				strLocalString.append("Auto, Fired, Red-eye reduction, Return not detected");
			else if(!strString.compare(string("95")))
				strLocalString.append("Auto, Fired, Red-eye reduction, Return detected");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x8822:	//ExposureProgram
			if(!strString.compare(string("1")))
				strLocalString.append("Manual");
			else if(!strString.compare(string("2")))
				strLocalString.append("Program AE");
			else if(!strString.compare(string("3")))
				strLocalString.append("Aperture-priority AE");
			else if(!strString.compare(string("4")))
				strLocalString.append("Shutter speed priority AE");
			else if(!strString.compare(string("5")))
				strLocalString.append("Creative (Slow speed)");
			else if(!strString.compare(string("6")))
				strLocalString.append("Action (High speed)");
			else if(!strString.compare(string("7")))
				strLocalString.append("Portrait");
			else if(!strString.compare(string("8")))
				strLocalString.append("Landscape");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x9207:	//MeteringMode
			if(!strString.compare(string("5")))
				strLocalString.append("Matrix");
			else if(!strString.compare(string("3")))
				strLocalString.append("Spot");
			else if(!strString.compare(string("2")))
				strLocalString.append("Center-weighted");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x0103:	//Compression
			if(!strString.compare(string("1")))
				strLocalString.append("Uncompressed");
			else if(!strString.compare(string("2")))
				strLocalString.append("CCITT 1D");
			else if(!strString.compare(string("3")))
				strLocalString.append("T4/Group 3 Fax");
			else if(!strString.compare(string("4")))
				strLocalString.append("T6/Group 4 Fax");
			else if(!strString.compare(string("5")))
				strLocalString.append("LZW");
			else if(!strString.compare(string("6")))
				strLocalString.append("JPEG (old-style)");
			else if(!strString.compare(string("7")))
				strLocalString.append("JPEG");
			else if(!strString.compare(string("8")))
				strLocalString.append("Adobe Deflate");
			else if(!strString.compare(string("9")))
				strLocalString.append("JBIG B&W");
			else if(!strString.compare(string("10")))
				strLocalString.append("JBIG Color");
			else if(!strString.compare(string("32766")))
				strLocalString.append("Next");
			else if(!strString.compare(string("32771")))
				strLocalString.append("CCIRLEW");
			else if(!strString.compare(string("32773")))
				strLocalString.append("PackBits");
			else if(!strString.compare(string("32809")))
				strLocalString.append("Thunderscan");
			else if(!strString.compare(string("32895")))
				strLocalString.append("IT8CTPAD");
			else if(!strString.compare(string("32896")))
				strLocalString.append("IT8LW");
			else if(!strString.compare(string("32897")))
				strLocalString.append("IT8MP");
			else if(!strString.compare(string("32898")))
				strLocalString.append("IT8BL");
			else if(!strString.compare(string("32908")))
				strLocalString.append("PixarFilm");
			else if(!strString.compare(string("32909")))
				strLocalString.append("PixarLog");
			else if(!strString.compare(string("32946")))
				strLocalString.append("Deflate");
			else if(!strString.compare(string("32947")))
				strLocalString.append("DCS");
			else if(!strString.compare(string("34661")))
				strLocalString.append("JBIG");
			else if(!strString.compare(string("34676")))
				strLocalString.append("SGILog");
			else if(!strString.compare(string("34677")))
				strLocalString.append("SGILog24");
			else if(!strString.compare(string("34712")))
				strLocalString.append("JPEG 2000");
			else if(!strString.compare(string("34713")))
				strLocalString.append("Nikon NEF Compressed");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x0213:	//YCbCrPositioning
			if(!strString.compare(string("1")))
				strLocalString.append("Centered");
			else if(!strString.compare(string("2")))
				strLocalString.append("Co-sited");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x0088:	//AFPoint
			strLocalString.resize(0);
			strLocalString.append(getAutoFocusData(strString, ulAFPoint));

			break;
		case 0x011c:	//PlanarConfiguration
			if(!strString.compare(string("1")))
				strLocalString.append("Chunky");
			else if(!strString.compare(string("2")))
				strLocalString.append("Planar");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0xa001:	//ColorSpace
			if(!strString.compare(string("1")))
				strLocalString.append("sRGB");
			else if(!strString.compare(string("2")))
				strLocalString.append("Adobe RGB");
			else if(!strString.compare(string("65535")))
				strLocalString.append("Uncalibrated");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0xa401:	//CustomRendered
			if(!strString.compare(string("0")))
				strLocalString.append("Normal");
			else if(!strString.compare(string("1")))
				strLocalString.append("Custom");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0xa403:	//WhiteBalance
			if(!strString.compare(string("0")))
				strLocalString.append("Auto");
			else if(!strString.compare(string("1")))
				strLocalString.append("Manual");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0xa300:	//FileSource
			if(!strString.compare(string("3")))
				strLocalString.append("Digital Camera");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0xa301:	//SceneType
			if(!strString.compare(string("1")))
				strLocalString.append("Directly photographed");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x9217:	//SensingMethod
		case 0xa217:	//SensingMethod
			if(!strString.compare(string("1")))
				strLocalString.append("Not defined");
			else if(!strString.compare(string("2")))
				strLocalString.append("One-chip color area");
			else if(!strString.compare(string("3")))
				strLocalString.append("Two-chip color area");
			else if(!strString.compare(string("4")))
				strLocalString.append("Three-chip color area");
			else if(!strString.compare(string("5")))
				strLocalString.append("Color sequential area");
			else if(!strString.compare(string("7")))
				strLocalString.append("Trilinear");
			else if(!strString.compare(string("8")))
				strLocalString.append("Color sequential linear");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x0106:	//PhotometricInterpretation
			if(!strString.compare(string("0")))
				strLocalString.append("WhiteIsZero");
			else if(!strString.compare(string("1")))
				strLocalString.append("BlackIsZero");
			else if(!strString.compare(string("2")))
				strLocalString.append("RGB");
			else if(!strString.compare(string("3")))
				strLocalString.append("RGB Palette");
			else if(!strString.compare(string("4")))
				strLocalString.append("Transparency Mask");
			else if(!strString.compare(string("5")))
				strLocalString.append("CMYK");
			else if(!strString.compare(string("6")))
				strLocalString.append("YCbCr");
			else if(!strString.compare(string("8")))
				strLocalString.append("CIELab");
			else if(!strString.compare(string("9")))
				strLocalString.append("ICCLab");
			else if(!strString.compare(string("10")))
				strLocalString.append("ITULab");
			else if(!strString.compare(string("32803")))
				strLocalString.append("Color Filter Array");
			else if(!strString.compare(string("32844")))
				strLocalString.append("Pixar LogL");
			else if(!strString.compare(string("32845")))
				strLocalString.append("Pixar LogLuv");
			else if(!strString.compare(string("34892")))
				strLocalString.append("Linear Raw");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x0128:	//ResolutionUnit
			if(!strString.compare(string("1")))
				strLocalString.append("None");
			else if(!strString.compare(string("2")))
				strLocalString.append("inches");
			else if(!strString.compare(string("3")))
				strLocalString.append("cm");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0xa406:	//SceneCaptureType
			if(!strString.compare(string("0")))
				strLocalString.append("Standard");
			else if(!strString.compare(string("1")))
				strLocalString.append("Landscape");
			else if(!strString.compare(string("2")))
				strLocalString.append("Portrait");
			else if(!strString.compare(string("3")))
				strLocalString.append("Night");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0xa407:	//GainControl
			if(!strString.compare(string("0")))
				strLocalString.append("None");
			else if(!strString.compare(string("1")))
				strLocalString.append("Low gain up");
			else if(!strString.compare(string("2")))
				strLocalString.append("High gain up");
			else if(!strString.compare(string("3")))
				strLocalString.append("Low gain down");
			else if(!strString.compare(string("4")))
				strLocalString.append("High gain down");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0xa40c:	//SubjectDistanceRange
			if(!strString.compare(string("1")))
				strLocalString.append("Macro");
			else if(!strString.compare(string("2")))
				strLocalString.append("Close");
			else if(!strString.compare(string("3")))
				strLocalString.append("Distant");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0xa408:	//Contrast
		case 0xa409:	//Saturation
		case 0xa40a:	//Sharpness
			iValue = atoi(strString.c_str());

			if(iValue > 0)
			{
				if(iValue > 0xfff0)
					iValue = iValue - 0x10000;
				
				//itoa(iValue, buffer, 10);
				sprintf(buffer, "%d", iValue);
				strLocalString.append(buffer);
			}
			else
			{
				if(iValue == 0)
					strLocalString.append("Normal");
			}
			break;
		case 0xa402:	//ExposureMode
			if(!strString.compare(string("0")))
				strLocalString.append("Auto");
			else if(!strString.compare(string("1")))
				strLocalString.append("Manual");
			else if(!strString.compare(string("2")))
				strLocalString.append("Auto bracket");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x0087:	//FlashMode
			if(!strString.compare(string("0")))
				strLocalString.append("Did Not Fire");
			else if(!strString.compare(string("1")))
				strLocalString.append("Fired, Manual");
			else if(!strString.compare(string("7")))
				strLocalString.append("Fired, External");
			else if(!strString.compare(string("8")))
				strLocalString.append("Fired, Commander Mode");
			else if(!strString.compare(string("9")))
				strLocalString.append("Fired, TTL Mode");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x0112:	//Orientation
			if(!strString.compare(string("1")))
				strLocalString.append("Horizontal (normal)");
			else if(!strString.compare(string("2")))
				strLocalString.append("Mirrored horizontal");
			else if(!strString.compare(string("3")))
				strLocalString.append("Rotated 180");
			else if(!strString.compare(string("4")))
				strLocalString.append("Mirrored vertical");
			else if(!strString.compare(string("5")))
				strLocalString.append("Mirrored horizontal then rotated 90 CCW");
			else if(!strString.compare(string("6")))
				strLocalString.append("Rotated 90 CW");
			else if(!strString.compare(string("7")))
				strLocalString.append("Mirrored horizontal then rotated 90 CW");
			else if(!strString.compare(string("8")))
				strLocalString.append("Rotated 90 CCW");
			else if(!strString.compare(string("8")))
				strLocalString.append("Rotated 90 CCW");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x0083:	//LensType
			if(!strString.compare(string("0")))
				strLocalString.append("Manual Focus");
			else if(!strString.compare(string("2")))
				strLocalString.append("D");
			else if(!strString.compare(string("6")))
				strLocalString.append("G");
			else if(!strString.compare(string("e")))
				strLocalString.append("G-VR");
			else if(!strString.compare(string("a")))
				strLocalString.append("D-VR");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x0084:	//Lens
			strLocalString.append(convertLens((char *) strString.c_str()));
			break;
		case 0x920a:	//FocalLength
			strLocalString.append(truncate((char *) strString.c_str(), precision((char *) strString.c_str())));
			strLocalString.append(" mm");
			break;
		case 0xa405:	//FocalLengthIn35mmFilm
			strLocalString.append(strString);
			strLocalString.append(" mm");
			break;
		case 0x829d:	//FNumber
			strLocalString.append(truncate((char *) strString.c_str(), 3));
			break;
		case 0x00b1:	//HighISONoiseReduction
			if(!strString.compare(string("0")))
				strLocalString.append("Off");
			else if(!strString.compare(string("1")))
				strLocalString.append("On for ISO 1600/3200");
			else if(!strString.compare(string("2")))
				strLocalString.append("Weak");
			else if(!strString.compare(string("4")))
				strLocalString.append("Normal");
			else if(!strString.compare(string("6")))
				strLocalString.append("Strong");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x008a:	//AutoBracketRelease
			if(!strString.compare(string("0")))
				strLocalString.append("None");
			else if(!strString.compare(string("1")))
				strLocalString.append("Auto Release");
			else if(!strString.compare(string("2")))
				strLocalString.append("Manual Release");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x001e:	//ColorSpace
			if(!strString.compare(string("1")))
				strLocalString.append("sRGB");
			else if(!strString.compare(string("2")))
				strLocalString.append("AdobeRGB");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		case 0x000d:	//ProgramShift
		case 0x0012:	//FlashCompensation
		case 0x0018:	//FlashExposureBracketValue

			if(!strString.compare(string("fc 01 06 00 ")))
				strLocalString.append("-2/3EV");
			else if(!strString.compare(string("fd 01 06 00 ")))
				strLocalString.append("-1/2EV");
			else if(!strString.compare(string("fe 01 06 00 ")))
				strLocalString.append("-1/3EV");
			else if(!strString.compare(string("00 01 06 00 ")))
				strLocalString.append("+-0EV");
			else if(!strString.compare(string("02 01 06 00 ")))
				strLocalString.append("+1/3EV");
			else if(!strString.compare(string("03 01 06 00 ")))
				strLocalString.append("+1/2EV");
			else if(!strString.compare(string("04 01 06 00 ")))
				strLocalString.append("+2/3EV");
			else
			{
				strLocalString.append("Unknown (");
				strLocalString.append(strString);
				strLocalString.append(")");
			}
			break;
		default:
			strLocalString.append(strString);
			break;
	}

	string strTemp = strLocalString;
	setDisplayStringData(strLocalString);
	return strLocalString;
}

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
int IFDElement::precision(char *str_value)
{
	int iPercision = 0;
	char *temp_ptr = NULL;
	char *token1 = NULL;
	char *token2 = NULL;

	temp_ptr = strdup(str_value);

	token1 = strtok(temp_ptr, ".");
	token2 = strtok(NULL, ".");

	if(token2[0] == '0')
		iPercision = 0;
	else
		iPercision = 2;

	return(iPercision);
}

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
char* IFDElement::truncate(char *str_token, int dec_len)
{
	char *temp_ptr = NULL;
	char *char_ptr = NULL;

	temp_ptr = strdup(str_token);

	char_ptr = strchr(temp_ptr, '.');

	char_ptr += dec_len;

	*char_ptr = (char) NULL;
	
	return(temp_ptr);
}


//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
char* IFDElement::convertLens(char *str_lens)
{
	char *temp_ptr = NULL;
	char *final_ptr = "lens";
	char *token1 = NULL;
	char *token2 = NULL;
	char *token3 = NULL;
	char *token4 = NULL;
	char buffer[256];

	memset(buffer, (int) '\0', 256);

	temp_ptr = strdup(str_lens);

	token1 = strtok(temp_ptr, " ");
	token2 = strtok(NULL, " ");
	token3 = strtok(NULL, " ");
	token4 = strtok(NULL, " ");

	if((!strcmp(token1, token2)) && (!strcmp(token3, token4)))
	{
		sprintf(buffer, "%s mm f/%s", truncate(token1, precision(token1)), truncate(token3, 2));
	}
	else
	{
		if(!strcmp(token3, token4))
			sprintf(buffer, "%s-%s mm f/%s", truncate(token1, precision(token1)), truncate(token2, 0), truncate(token3, 2));
		else
			sprintf(buffer, "%s-%s mm f/%s-%s", truncate(token1, precision(token1)), truncate(token2, 0), truncate(token3, 2), truncate(token4, 2));
	}

	temp_ptr = (char *) malloc((strlen(buffer) + 1));
	memset(temp_ptr, (int) '\0', (strlen(buffer) + 1));
	strcpy(temp_ptr, buffer);

	final_ptr = strdup(temp_ptr);

	free(temp_ptr);

	return(final_ptr);
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
string& IFDElement::processTypeSeven(FILE *rfd)
{
	static string strLocalString;
	char buffer[256];
	long position = 0l;

	unsigned long ulTmpOffset = 0l;
	unsigned int ubyte1 = 0;
	unsigned int ubyte2 = 0;
	unsigned int ubyte3 = 0;
	unsigned int ubyte4 = 0;
	unsigned long ulong = 0l;
	float fnumber = 0.0f;
	unsigned short usTag = getTag();

	position = ftell(rfd);

	strLocalString.resize(0);
	ulTmpOffset = getOffset();

	if( ReverseByteOrder() )
		ulTmpOffset = rev_dword( ulTmpOffset );

	if(getTag() == 0xA300 || 
	   getTag() == 0xA301)
	{
		ulong = ulTmpOffset;
		ubyte1 = (ulong & 0xff000000) >> 24;
		ubyte2 = (ulong & 0x00ff0000) >> 16;
		ubyte3 = (ulong & 0x0000ff00) >> 8;
		ubyte4 = (ulong & 0x000000ff);

		memset(buffer, (int) '\0', 256);
#ifdef APPLE
		sprintf(buffer, "%x", ubyte1);
#else
		sprintf(buffer, "%x", ubyte4);
#endif	// APPLE 
		strLocalString.append(buffer);
		setIsLessThanFourBytes(true);
	}

	if(getTag() == 0x008B)
	{
		// translated from a C++ function created by:
		// (c) Robert Rottmerhusen 2005

		ulong = ulTmpOffset;
		ubyte1 = (ulong & 0xff000000) >> 24;
		ubyte2 = (ulong & 0x00ff0000) >> 16;
		ubyte3 = (ulong & 0x0000ff00) >> 8;
		ubyte4 = (ulong & 0x000000ff);

#ifdef APPLE
		if(ubyte3)
			fnumber = (float) ubyte1 * ((float) ubyte2/(float) ubyte3);
#else
		if(ubyte2)
			fnumber = (float) ubyte4 * ((float) ubyte3/(float) ubyte2);
#endif	// APPLE

		memset(buffer, (int) '\0', 256);
		sprintf(buffer, "%0.2f", fnumber);
		strLocalString.append(buffer);
		setIsLessThanFourBytes(true);
	}

	if((getTag() == 0x0002)	&& (getIFDType() == 10))	//InteropVersion
	{
		strLocalString.append((char *) &ulTmpOffset);
		strLocalString.resize(4);
		setIsLessThanFourBytes(true);
	}

	if(getTag() == 0x0088)	//AFPoint
	{
		ulong = getOffset();
		ulAFPoint = ulong;

		memset(buffer, (int) '\0', 256);
		sprintf(buffer, "0x%08x", ulong);
		strLocalString.append(buffer);
		setIsLessThanFourBytes(true);
	}

	if(getTag() == 0x0001 ||	//FileSystemVersion
	   getTag() == 0x9000 ||	//ExifVersion
	   getTag() == 0xA000)		//FlashPixVersion
	{
		strLocalString.append((char *) &ulTmpOffset);
		strLocalString.resize(4);
		setIsLessThanFourBytes(true);
	}

	if(getTag() == 0x000D ||
	   //getTag() == 0x000E ||
	   getTag() == 0x0012 ||
	   getTag() == 0x0017 ||
	   getTag() == 0x0018 ||
	   getTag() == 0x00A4 ||
	   getTag() == 0x9101)
	{
		char buffer1[256];
		memset(buffer1, (int) '\0', 256);
		memcpy(&buffer1[0], &ulTmpOffset, getCount()); 

		for(int ctr1 = 0; ctr1 < getCount(); ctr1++)
		{
			char buffer2[5];
			char buffer3[5];
			memset(buffer2, (int) '\0', 5);
			memset(buffer3, (int) '\0', 5);
			memcpy(&buffer2[0], &buffer1[ctr1], 1);

			sprintf(buffer3, "%02x", buffer2[0]);

			strLocalString.append(buffer3);
			strLocalString.append(string(" "));
		}

		setIsLessThanFourBytes(true);
	}

	if(getTag() == 0xA302 ||
	   getTag() == 0x008C ||
	   getTag() == 0x0091 ||
	   getTag() == 0x0096 ||
	   getTag() == 0x0097 ||
	   getTag() == 0x00A8 ||
	   getTag() == 0x001F ||	// JON JON JON - VRInfo
	   getTag() == 0x00B0 ||	// JON JON JON - MultiExposure
	   getTag() == 0x00B7 ||	// JON JON JON - AFInfo2
	   getTag() == 0x0E0E ||
	   getTag() == 0x0098)
	{
		fseek(rfd, getOffset() + getAdjustedOffset(), 0);
		
		unsigned long ulCount = getCount();
		unsigned char * byte_ptr;
		unsigned char *free_ptr;
		byte_ptr = (unsigned char *) malloc(getCount() + 1);
		free_ptr = byte_ptr;
		memset(byte_ptr, (int) '\0', getCount() + 1);

		fread(byte_ptr, getCount(), 1, rfd);

		if(ulCount > 40)	//JON JON JON
			ulCount = 40;

		for(int ctr1 = 0; ctr1 < ulCount; ctr1++)
		{
			memset(buffer, (int) '\0', 256);
			sprintf(buffer, "%02x ", *byte_ptr);
			strLocalString.append(buffer);
			byte_ptr++;
		}

		free(free_ptr);
		setIsLessThanFourBytes(false);
	}

	if(getTag() == 0x9286)
	{
		fseek(rfd, getOffset() + getAdjustedOffset() + getASCILabelSkipLength(), 0);

		char *byte_ptr = (char *) malloc(getCount() + 1);
		memset(byte_ptr, (int) '\0', (getCount() + 1));

		fread(byte_ptr, getCount() - getASCILabelSkipLength(), 1, rfd);

		strLocalString.append(byte_ptr);
		free(byte_ptr);
		setIsLessThanFourBytes(false);
	}

	if(getTag() == 0x927C)
	{
		memset(buffer, (int) '\0', 256);
		sprintf(buffer, "%ld", getOffset());
		strLocalString.append(buffer);
		setIsLessThanFourBytes(true);
	}

	if(getTag() == 0x000E)	// ExposureDifference
	{
		char buffer1[256];
		memset(buffer1, (int) '\0', 256);
		memcpy(&buffer1[0], &ulTmpOffset, getCount()); 

		double dByte1 = 0.0;
		double dByte2 = 0.0;
		double dByte3 = 0.0;
		double dByte4 = 0.0;

		int iTemp = 0;

		for(int ctr1 = 0; ctr1 < getCount(); ctr1++)
		{
			char buffer2[5];
			memset(buffer2, (int) '\0', 5);
			memcpy(&buffer2[0], &buffer1[ctr1], 1);

			iTemp = (int) buffer2[0];

			if(iTemp > 0)
			{
				if(iTemp > 0xfff0)
					iTemp = iTemp - 0x10000;
			}

			if(ctr1 == 0)
				dByte1 = (double) iTemp;
			if(ctr1 == 1)
				dByte2 = (double) iTemp;
			if(ctr1 == 2)
				dByte3 = (double) iTemp;
			if(ctr1 == 3)
				dByte4 = (double) iTemp;
		}

		char buffer3[50];
		memset(buffer3, (int) '\0', 50);

		sprintf(buffer3, "%f", (dByte1 * (dByte2 / dByte3)));
		strLocalString.append(buffer3);

		setIsLessThanFourBytes(true);
	}

	fseek( rfd, position, SEEK_SET );
	return strLocalString;
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
string& IFDElement::getTypeNineLessThan4Value()
{
	return getTypeFourLessThan4Value();
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
string& IFDElement::getTypeFourLessThan4Value()
{
	static string strBuffer;
	char buffer[64];
	unsigned long ulong = 0l;

	strBuffer.resize(0);

	ulong = getOffset();

	sprintf(buffer, "%ld", ulong);

	strBuffer = string(buffer);

	return strBuffer;
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
string& IFDElement::getTypeSixLessThan4Value()
{
	static string strBuffer;
	char buffer[64];
	int ibyte_count = 0;
	unsigned int ubyte1 = 0;
	unsigned int ubyte2 = 0;
	unsigned int ubyte3 = 0;
	unsigned int ubyte4 = 0;
	unsigned long ulong = 0l;

	strBuffer.resize(0);

	ibyte_count = getCount();
	ulong = getOffset();

	ubyte1 = (ulong & 0xff000000) >> 24;
	ubyte2 = (ulong & 0x00ff0000) >> 16;
	ubyte3 = (ulong & 0x0000ff00) >> 8;
	ubyte4 = (ulong & 0x000000ff) >> 0;

	if(ibyte_count == 1)
	{
		sprintf(buffer, "%d", ubyte1);
	}
	else if(ibyte_count == 2)
	{
		sprintf(buffer, "%d %d", ubyte1, ubyte2);
	}
	else if(ibyte_count == 3)
	{
		sprintf(buffer, "%d %d %d", ubyte1, ubyte2, ubyte3);
	}
	else if(ibyte_count == 4)
	{
		sprintf(buffer, "%d %d %d %d", ubyte1, ubyte2, ubyte3, ubyte4);
	}

	strBuffer = string(buffer);

	return strBuffer;
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
string& IFDElement::getTypeOneLessThan4Value()
{
	static string strBuffer;
	char buffer[64];
	int ibyte_count = 0;
	unsigned int ubyte1 = 0;
	unsigned int ubyte2 = 0;
	unsigned int ubyte3 = 0;
	unsigned int ubyte4 = 0;
	unsigned long ulong = 0l;

	strBuffer.resize(0);

	ibyte_count = getCount();
	ulong = getOffset();

	ubyte1 = (ulong & 0xff000000) >> 24;
	ubyte2 = (ulong & 0x00ff0000) >> 16;
	ubyte3 = (ulong & 0x0000ff00) >> 8;
	ubyte4 = (ulong & 0x000000ff) >> 0;

#ifdef APPLE
	if(!ReverseByteOrder())
#else
	if(ReverseByteOrder())
#endif	// APPLE
	{
		if(ibyte_count == 1)
		{
			sprintf(buffer, "%x", ubyte1);
		}
		else if(ibyte_count == 2)
		{
			sprintf(buffer, "%x %x", ubyte1, ubyte2);
		}
		else if(ibyte_count == 3)
		{
			sprintf(buffer, "%x %x %x", ubyte1, ubyte2, ubyte3);
		}
		else if(ibyte_count == 4)
		{
			sprintf(buffer, "%x %x %x %x", ubyte1, ubyte2, ubyte3, ubyte4);
		}
	}
	else
	{
		if(ibyte_count == 1)
		{
			sprintf(buffer, "%x", ubyte4);
		}
		else if(ibyte_count == 2)
		{
			sprintf(buffer, "%x %x", ubyte4, ubyte3);
		}
		else if(ibyte_count == 3)
		{
			sprintf(buffer, "%x %x %x", ubyte4, ubyte3, ubyte2);
		}
		else if(ibyte_count == 4)
		{
			sprintf(buffer, "%x %x %x %x", ubyte4, ubyte3, ubyte2, ubyte1);
		}
	}

	strBuffer = string(buffer);

	return strBuffer;
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
string& IFDElement::getTypeEightLessThan4Value()
{
	static string strBuffer;
	char buffer[64];
	int ibyte_count = 0;
	int sbyte5 = 0;
	int sbyte6 = 0;
	long slong = 0l;

	strBuffer.resize(0);

	ibyte_count = 2 * getCount();
	slong = getOffset();

	sbyte5 = (int) ((slong & (long) 0xffff0000) >> 16);
	sbyte6 = (int) ((slong & (long) 0x0000ffff) >> 0);

	if((getTag() == 0x000b) ||	//WhiteBalanceFine
		(getTag() == 0x0092))	//HueAdjustment
	{
		if(sbyte6 > 0xfff0)
			sbyte6 = sbyte6 - 0x10000;

		if(ReverseByteOrder())
			sprintf(buffer, "%d", sbyte5);
		else
			sprintf(buffer, "%d", sbyte6);
	}
	else
	{
		if(ibyte_count == 2)
		{
			if(ReverseByteOrder())
				sprintf(buffer, "%d", sbyte5);
			else
				sprintf(buffer, "%d", sbyte6);
		}
		else if(ibyte_count == 4)
		{
			sprintf(buffer, "%d %d", sbyte5, sbyte6);
		}
	}

	strBuffer = string(buffer);

	return strBuffer;
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
string& IFDElement::getTypeThreeLessThan4Value()
{
	static string strBuffer;
	char buffer[64];
	int ibyte_count = 0;
	unsigned int ubyte5 = 0;
	unsigned int ubyte6 = 0;
	unsigned long ulong = 0l;

	strBuffer.resize(0);

	ibyte_count = 2 * getCount();
	ulong = getOffset();

	memset(buffer, (int) '\0', 64);

	ubyte5 = (ulong & 0xffff0000) >> 16;
	ubyte6 = (ulong & 0x0000ffff) >> 0;

	if((getTag() == 0x0002) || (getTag() == 0x0013))
	{
		if(ubyte6 != 0)
			sprintf(buffer, "%d", ubyte6);
		else
			sprintf(buffer, "%d", ubyte5);
	}
	else
	{
		if(ibyte_count == 2)
		{
#ifdef APPLE
			if(!ReverseByteOrder())
#else
			if(ReverseByteOrder())
#endif	// APPLE
				sprintf(buffer, "%d", ubyte5);
			else
				sprintf(buffer, "%d", ubyte6);
		}
		else if(ibyte_count == 4)
		{
			sprintf(buffer, "%d %d", ubyte5, ubyte6);
		}
	}

	strBuffer.append(buffer);

	return strBuffer;
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
string& IFDElement::getTypeTwoLessThan4Value()
{
	static string strBuffer;
	char buffer[64];
	int ibyte_count = 0;
	unsigned int ubyte1 = 0;
	unsigned int ubyte2 = 0;
	unsigned int ubyte3 = 0;
	unsigned int ubyte4 = 0;
	unsigned long ulong = 0l;

	strBuffer.resize(0);

	ibyte_count = getCount();
	ulong = getOffset();

	ubyte1 = (ulong & 0xff000000) >> 24;
	ubyte2 = (ulong & 0x00ff0000) >> 16;
	ubyte3 = (ulong & 0x0000ff00) >> 8;
	ubyte4 = (ulong & 0x000000ff) >> 0;

	if(ibyte_count == 1)
	{
		sprintf(buffer, "%c", ubyte1);
	}
	else if(ibyte_count == 2)
	{
		sprintf(buffer, "%c%c", ubyte1, ubyte2);
	}
	else if(ibyte_count == 3)
	{
#ifdef APPLE
		if(!ReverseByteOrder())
#else
		if(ReverseByteOrder())
#endif	// APPLE
			sprintf(buffer, "%c%c%c", ubyte1, ubyte2, ubyte3);
		else
			sprintf(buffer, "%c%c%c", ubyte4, ubyte3, ubyte2);
	}
	else if(ibyte_count == 4)
	{
		sprintf(buffer, "%c%c%c%c", ubyte1, ubyte2, ubyte3, ubyte4);
	}

	strBuffer = string(buffer);

	return strBuffer;
}


//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
string& WebConfig::getTextElementValue()
{
	static string strLocalString;

	strLocalString.resize(0);

	int iPos = strTextElement.find_first_of ('=', 0);

	strLocalString.append(strTextElement, (iPos + 1), (strTextElement.length() - iPos));

	return strLocalString;
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
void IFDElement::list()
{
	char buffer[256];

	//cout << "\n\nData List Start: ";
	strGlobalCOut.append("\n\nData List Start: ");

	memset(buffer, (int) '\0', 256);
	sprintf(buffer, "%d(0x%x)", ifde.tag, ifde.tag);
	
	//cout << "\nifde.tag               : " << buffer;
	strGlobalCOut.append("\nifde.tag               : ");
	strGlobalCOut.append(buffer);

	//cout << "\nifde.type              : " << ifde.type;
	strGlobalCOut.append("\nifde.type              : ");

	memset(glb_buffer, '\0', GLB_SIZE);
	sprintf(glb_buffer, "%d", ifde.type);
	strGlobalCOut.append(glb_buffer);
	
	//cout << "\nifde.count             : " << ifde.count;
	strGlobalCOut.append("\nifde.count             : ");

	memset(glb_buffer, '\0', GLB_SIZE);
	sprintf(glb_buffer, "%ld", ifde.count);
	strGlobalCOut.append(glb_buffer);


	memset(buffer, (int) '\0', 256);
	sprintf(buffer, "%d(0x%x)", ifde.valofs, ifde.valofs);
	//cout << "\nifde.valofs            : " << buffer;
	strGlobalCOut.append("\nifde.valofs            : ");
	strGlobalCOut.append(buffer);

	memset(buffer, (int) '\0', 256);
	sprintf(buffer, "%ld(0x%x)", lAdjustedOffset, lAdjustedOffset);
	//cout << "\nlAdjustedOffset        : " << buffer;
	strGlobalCOut.append("\nlAdjustedOffset        : ");
	strGlobalCOut.append(buffer);

	memset(buffer, (int) '\0', 256);
	sprintf(buffer, "%ld(0x%x)", ulTagWriteOffset, ulTagWriteOffset);
	//cout << "\nulTagWriteOffset       : " << buffer;
	strGlobalCOut.append("\nulTagWriteOffset       : ");
	strGlobalCOut.append(buffer);

	memset(buffer, (int) '\0', 256);
	sprintf(buffer, "%ld(0x%x)", ulValueWriteOffset, ulValueWriteOffset);
	//cout << "\nulValueWriteOffset     : " << buffer;
	strGlobalCOut.append("\nulValueWriteOffset     : ");
	strGlobalCOut.append(buffer);

	memset(buffer, (int) '\0', 256);
	sprintf(buffer, "%ld(0x%x)", ulMakerNoteHeaderOffset, ulMakerNoteHeaderOffset);
	//cout << "\nulMakerNoteHeaderOffset: " << buffer;
	strGlobalCOut.append("\nulMakerNoteHeaderOffset: ");
	strGlobalCOut.append(buffer);

	memset(buffer, (int) '\0', 256);
	sprintf(buffer, "%ld(0x%x)", lFileSize, lFileSize);
	//cout << "\nlFileSize              : " << buffer;
	strGlobalCOut.append("\nlFileSize              : ");
	strGlobalCOut.append(buffer);

	//cout << "\niIFDType               : " << iIFDType;
	strGlobalCOut.append("\niIFDType               : ");

	memset(glb_buffer, '\0', GLB_SIZE);
	sprintf(glb_buffer, "%d", iIFDType);
	strGlobalCOut.append(glb_buffer);

	//cout << "\nisWantedValue          : " << isWantedValue;
	strGlobalCOut.append("\nisWantedValue          : ");

	if(isWantedValue)
		strGlobalCOut.append("true");
	else
		strGlobalCOut.append("false");

	//cout << "\nisLessThanFourBytes    : " << isLessThanFourBytes;
	strGlobalCOut.append("\nisLessThanFourBytes    : ");

	if(isLessThanFourBytes)
		strGlobalCOut.append("true");
	else
		strGlobalCOut.append("false");

	//cout << "\niFileType              : " << iFileType;
	strGlobalCOut.append("\niFileType              : ");
	
	memset(glb_buffer, '\0', GLB_SIZE);
	sprintf(glb_buffer, "%d", iFileType);
	strGlobalCOut.append(glb_buffer);

	//cout << "\niImageType             : " << iImageType;
	strGlobalCOut.append("\niImageType             : ");
	
	memset(glb_buffer, '\0', GLB_SIZE);
	sprintf(glb_buffer, "%d", iImageType);
	strGlobalCOut.append(glb_buffer);

	//cout << "\niASCILabelSkipLength   : " << iASCILabelSkipLength;
	strGlobalCOut.append("\niASCILabelSkipLength   : ");
	
	memset(glb_buffer, '\0', GLB_SIZE);
	sprintf(glb_buffer, "%d", iASCILabelSkipLength);
	strGlobalCOut.append(glb_buffer);

	//cout << "\nprogramName            : " << programName;
	strGlobalCOut.append("\nprogramName            : ");
	strGlobalCOut.append(programName);

	//cout << "\nprogramVersion         : " << programVersion;
	strGlobalCOut.append("\nprogramVersion         : ");
	strGlobalCOut.append(programVersion);

	//cout << "\nprogramDate            : " << programDate;
	strGlobalCOut.append("\nprogramDate            : ");
	strGlobalCOut.append(programDate);

	//cout << "\nfileName               : " << fileName;
	strGlobalCOut.append("\nfileName               : ");
	strGlobalCOut.append(fileName);

	//cout << "\nstringData             : " << stringData;
	strGlobalCOut.append("\nstringData             : ");
	strGlobalCOut.append(stringData);

	//cout << "\ndisplayStringData      : " << displayStringData;
	strGlobalCOut.append("\ndisplayStringData      : ");
	strGlobalCOut.append(displayStringData);

	//cout << "\nrawData                : [" << rawData << "]";
	strGlobalCOut.append("\nrawData                : [");
	strGlobalCOut.append(rawData);
	strGlobalCOut.append("]");

	//cout << "\nData List End.\n";
	strGlobalCOut.append("\nData List End.\n");
}

//--------------------------------------------------------------------------
//
//--------------------------------------------------------------------------
string getAutoFocusData(string strString, unsigned long ulInput)
{
	unsigned long ulTemp = 0l;
	unsigned long ulAFAreaMode = ulInput;
	unsigned long ulAFPoint = ulInput;
	unsigned long ulAFPointsUsed = ulInput;
	string strFinal;

	ulAFAreaMode >>= 24;
	ulAFPointsUsed <<= 16;
	ulAFPointsUsed >>= 16;
	ulTemp = ulInput << 8;
	ulAFPoint = ulTemp >> 24; 

	switch(ulAFAreaMode)
	{
	case 0:
		strFinal.append("Single Area, ");
		break;
	case 1:
		strFinal.append("Dynamic Area, ");
		break;
	case 2:
		strFinal.append("Dynamic Area, Closest Subject, ");
		break;
	case 3:
		strFinal.append("Group Dynamic, ");
		break;
	case 4:
		strFinal.append("Single Area (wide), ");
		break;
	case 5:
		strFinal.append("Dynamic Area (wide), ");
		break;
	default:
		strFinal.append("Unknown AFAreaMode (");
		strFinal.append(strString);
		strFinal.append(") ");
		break;
	}

/*
        PrintConv => {
            0 => 'Single Area',
            1 => 'Dynamic Area',
            2 => 'Dynamic Area, Closest Subject',
            3 => 'Group Dynamic',
            4 => 'Single Area (wide)',
            5 => 'Dynamic Area (wide)',
*/

	switch(ulAFPoint)
	{
	case 0:
		strFinal.append("Center");
		break;
	case 1:
		strFinal.append("Top");
		break;
	case 2:
		strFinal.append("Bottom");
		break;
	case 3:
		strFinal.append("Left");
		break;
	case 4:
		strFinal.append("Right");
		break;
	case 5:
		strFinal.append("Upper-left");
		break;
	case 6:
		strFinal.append("Upper-right");
		break;
	case 7:
		strFinal.append("Lower-left");
		break;
	case 8:
		strFinal.append("Lower-right");
		break;
	case 9:
		strFinal.append("Far Left");
		break;
	case 10:
		strFinal.append("Far Right");
		break;
	default:
		strFinal.append("\nUnknown AFAFPoint (");
		strFinal.append(strString);
		strFinal.append(") ");
		break;
	}

/*
        PrintConv => {
            0 => 'Center',
            1 => 'Top',
            2 => 'Bottom',
            3 => 'Left',
            4 => 'Right',
            5 => 'Upper-left',
            6 => 'Upper-right',
            7 => 'Lower-left',
            8 => 'Lower-right',
            9 => 'Far Left',
            10 => 'Far Right',
*/

	strFinal.append(" - ");
	strFinal.append(strString);

	return strFinal;
}
