/************************************************************************/
/*      $Id: d70claifd.hpp,v 1.5 2005/12/29 17:26:01 joman Exp joman $  */
/*                                                                      */
/*      Include file name:   d70claifd.hpp                              */
/*                                                                      */
/************************************************************************/
/*      Revisions:                                                      */
/*                                                                      */
/*      Version 0.01 - Tue May 10 14:47:38 EDT 2005:                    */
/*              First coding.                                           */
/************************************************************************/
#ifndef _D70CLAIFD_HPP
#define _D70CLAIFD_HPP

using namespace std;

class IFDElement
{
	IFDENTRY ifde;
	int iIFDType;
	unsigned long lAdjustedOffset;
	bool isWantedValue;
	bool isLessThanFourBytes;

	unsigned long ulTagWriteOffset;
	unsigned long ulValueWriteOffset;

	unsigned long ulMakerNoteHeaderOffset;
	int iFileType;
	int iImageType;
	int iASCILabelSkipLength;

	long lFileSize;

	string programName;
	string programVersion;
	string programDate;
	string fileName;
	string stringData;
	string displayStringData;
	string rawData;

public:

	IFDElement() { }
	IFDElement(IFDENTRY ifde_in, int iIFDType_in) { ifde = ifde_in; iIFDType = iIFDType_in; }
	~IFDElement() { }
	IFDElement& operator=(IFDElement &node);
	bool operator==(IFDElement &node);

	IFDENTRY getIFD() { return ifde; }
	IFDENTRY *getIFDAddress() { return &ifde; }
	void setIFD(IFDENTRY ifde_in) { ifde = ifde_in; }

	int getIFDType() { return iIFDType; }
	char * getIFDType(int iIFDType_in) { return TiffIFDTypeName(iIFDType_in); }
	void setIFDType(int iIFDType_in) { iIFDType = iIFDType_in; }

	//----------------------------------------------
	int getFileSize() { return lFileSize; }
	void setFileSize(int lFileSize_in) { lFileSize = lFileSize_in; }

	int getFileTypeOffset() { return iImageType; }
	void setFileTypeOffset(int iImageType_in) { iImageType = iImageType_in; }

	unsigned long getMakerNoteHdrOffset() { return ulMakerNoteHeaderOffset; }
	void setMakerNoteHdrOffset(unsigned long ulMakerNoteHeaderOffset_in) { ulMakerNoteHeaderOffset = ulMakerNoteHeaderOffset_in; }

	int getFileType() { return iFileType; }
	void setFileType(int iFileType_in) { iFileType = iFileType_in; }

	int getASCILabelSkipLength() { return iASCILabelSkipLength; }
	void setASCILabelSkipLength(int iASCILabelSkipLength_in) { iASCILabelSkipLength = iASCILabelSkipLength_in; }

	int getTagWriteOffset() { return ulTagWriteOffset; }
	void setTagWriteOffset(int ulTagWriteOffset_in) { ulTagWriteOffset = ulTagWriteOffset_in; }
	
	int getValueWriteOffset() { return ulValueWriteOffset; }
	void setValueWriteOffset(unsigned long ulValueWriteOffset_in) { ulValueWriteOffset = ulValueWriteOffset_in; }
	//----------------------------------------------
	bool getIsLessThanFourBytes() { return isLessThanFourBytes; }
	void setIsLessThanFourBytes(bool isLessThanFourBytes_in ) { isLessThanFourBytes = isLessThanFourBytes_in; }

	bool isWanted() { return isWantedValue; }
	void setIsWanted(bool isWantedValue_in ) { isWantedValue = isWantedValue_in; }

	unsigned short getTag() { return ifde.tagval(); }
	unsigned short getType() { return ifde.typeval(); }
	unsigned long getCount() { return ifde.countval(); }
	unsigned long getOffset() { return ifde.offsetval(); }

	unsigned long getAdjustedOffset() { return lAdjustedOffset; }
	void setAdjustedOffset(int lAdjustedOffset_in) { lAdjustedOffset = lAdjustedOffset_in; }

	string &getProgramName() { return programName; }
	void setProgramName(const string& programName_in) { programName = programName_in; }

	string &getProgramVersion() { return programVersion; }
	void setProgramVersion(const string& programVersion_in) { programVersion = programVersion_in; }

	string &getProgramDate() { return programDate; }
	void setProgramDate(const string& programDate_in) { programDate = programDate_in; }

	string &getFileName() { return fileName; }
	void setFileName(const string& fileName_in) { fileName = fileName_in; }

	string &getData() { return stringData; }
	void setData(FILE *rfd);
	void setData(const string& stringData_in) { stringData = stringData_in; }	//

	string &getDisplayStringData() { return displayStringData; }
	void setDisplayStringData(const string& displayStringData_in) { displayStringData = displayStringData_in; }

	string &getRawData() { return rawData; }
	void setRawData(const string& rawData_in) { rawData = rawData_in; }

	void setStringData(string& stringData_in) { stringData = stringData_in; }
	string& getTypeTwoLessThan4Value();
	string& getTypeThreeLessThan4Value();
	string& getTypeEightLessThan4Value();
	string& getTypeOneLessThan4Value();
	string& getTypeFourLessThan4Value();
	string& getTypeNineLessThan4Value();
	string& getTypeSixLessThan4Value();
	string& processTypeSeven(FILE *rfd);
	string& setDisplayData(const string& strString);
	int precision(char *str_value);
	char* truncate(char *str_token, int dec_len);
	char* convertLens(char *str_lens);

	void list();
};

class WantedTags
{
	bool isWantedValue;
	unsigned short usTag;
	int iIFDType;

public:

	WantedTags() { }
	WantedTags(bool isWantedValue_in, unsigned short usTag_in, int iIFDType_in) { isWantedValue = isWantedValue_in; usTag = usTag_in; iIFDType = iIFDType_in; }

	~WantedTags() { }

	bool isWanted() { return isWantedValue; }
	void setIsWanted(bool isWantedValue_in ) { isWantedValue = isWantedValue_in; }

	unsigned int getTag() { return usTag; }
	void setTag(unsigned int usTag_in) { usTag = usTag_in; }

	int getIFDType() { return iIFDType; }
	void setIFDType(int iIFDType_in) { iIFDType = iIFDType_in; }
};

class IFDTypeOffset
{
	int iIFDType;
	unsigned short usOffset;

public:

	IFDTypeOffset( )
	{
		iIFDType = 0;
		usOffset = 0;
	}
	IFDTypeOffset( int iIFDType_in, unsigned short usOffset_in )
	{
		iIFDType = iIFDType_in;
		usOffset = usOffset_in;
	}
	~IFDTypeOffset( )
	{
	}

	int getIFDType( void ) { return iIFDType; }
	void setIFDType( int iIFDType_in ) { iIFDType = iIFDType_in; }

	unsigned short getOffset( void ) { return usOffset; }
	void setOffset( unsigned short usOffset_in ) { usOffset = usOffset_in; }

};

class WebConfig
{
	string strTextElement;

public:

	WebConfig() { }
	WebConfig(const string& strTextElement_in) { strTextElement = strTextElement_in; }

	~WebConfig() { }

	string& getTextElementValue();
	string& getTextElement() { return strTextElement; }
	void setTextElement(const string& strTextElement_in) { strTextElement = strTextElement_in; }
};


#endif //_D70CLAIFD_HPP
