/************************************************************************/
/*      $Id: d70inc2.h,v 1.12 2006/02/18 19:00:29 joman Exp joman $     */
/*                                                                      */
/*      Include file name:   d70inc2.h                                  */
/*                                                                      */
/************************************************************************/
/*      Revisions:                                                      */
/*                                                                      */
/*      Version 0.01 - Tue May 10 14:47:38 EDT 2005:                    */
/*              First coding.                                           */
/************************************************************************/
#ifndef _D70INC2_H
#define _D70INC2_H

#include <vector>

using namespace std;

#define LARGE_IMAGE_HEIGHT 600
#define LARGE_IMAGE_WIDTH 800
#define LARGE_IMAGE_LENGTH 800

#ifndef GLB_SIZE
#define GLB_SIZE 128
#endif

extern string strGlobalCOut;
extern char glb_buffer[GLB_SIZE];

extern int iWeb_First_Time;
extern int iWeb_Image_count;
extern int iRoot_Web_Image_count;
extern int iWeb_Gallery_count;
extern char *web_file_name_src_ptr;
extern char *web_file_name_tmp_ptr;
extern FILE *gallery_ofd;
extern FILE *root_ofd;
extern int iGlobalImageWidth;
extern int iGlobalImageHeight;
extern int	iSizeTestCompleted;
extern char *str_root_temp_dir;
extern unsigned long lThumbnailOffset;
extern unsigned long lThumbnailLength;
extern char *GlobalOrientationPtr;

extern const int iASCILabelSkipLength;
extern const unsigned long ulMakerNotePreHeaderLength;

extern bool bTrace;
extern bool bVerbos;
extern bool bHtml;
extern bool bXml;
extern bool bThumbnail;
extern bool bThumbnailOld;
extern bool bCsv;
extern bool bJS;
extern bool bWeb;
extern bool bRemoveEXIF;
extern bool bOutputPlain;
extern bool bNewConfig;
extern bool bNewCoC;
extern bool bRenameImage;
extern bool bOutputDirectory;
extern bool bRestoreEXIF;
extern bool bFixDate;
extern bool bFixDateWithOffset;
extern bool bSortPlain;
extern bool bJpegFine;
extern bool bMainUseCameraWB;
extern bool bMainUseAutoWB;
extern bool bMainUseCameraRGB;
extern bool bMainBright;
extern bool bMainRed;
extern bool bMainBlue;
extern bool bMainBlack;
extern bool bMainDoNotClipColor;

extern float fMainBright;
extern float fMainRed;
extern float fMainBlue;
extern int iMainBlack;
extern int iFixDateOffset;

extern string strTargetEXIFFileName;
extern string strConfigFile;
extern string strOutputDirectory;
extern string strWebSrcPathname;
extern string strWebPathName;
extern bool bNewlyCreatedD70;
extern bool bNewlyCreatedWeb;
extern string strCicleOfConfusion;
extern string strRenamePrefix;

extern string strModifyDate;
extern string strDateTimeOriginal;
extern string strDateTimeDigitized;

extern int iSystemType;
extern int iImageType;
extern int iFileType;
extern unsigned long ulMakerNoteHeaderOffset;
extern unsigned long ulCalcMakerNoteHeaderOffset;
extern int js_ctr1;
extern int js_total_count;

extern bool bCsvFirstTime;
extern bool bJSFlagFirstTime;
extern bool bJSFirstTime;
extern bool bReverse;

extern double dFocusDistance;

extern long lFileSize;

extern string& instruct();
extern int imageType();
extern int fileTypeOffset();
extern int dumpImageFileDirectory(FILE *rfd, long offset, long additional_offset, std::string& strType, int numType);
extern bool isTagWanted(unsigned short usTag, int iType);
extern string& ProcessFile(char *filename);
extern char *strip(char *str_input);
extern bool isTagYes(char *local_ptr);
extern void checkForConfig();
extern char *upperCase(char *local_ptr);
extern void outputPlain();
extern int my_mkdir(char *str_ptr);
extern int my_rmdir(char *str_ptr);
extern void my_error(FILE *rfd);
extern void my_fseek(FILE *rfd, long pos, int offset);
extern void my_exit(char *text_ptr);
extern void my_jpg_exit(char *text_ptr);
extern unsigned long getJpgTypeAndOffset(FILE *rfd, unsigned long offset);
extern unsigned long inspectImageFileHeader(FILE *rfd, int iType);
extern int fileTypeOffset();
extern string& getDataValue(unsigned short usTag, int iType, bool bMainList);
extern void outputHtml();
extern void outputXml();
extern void outputCsv();
extern void outputJs(FILE *ofd, bool bFirstTime, int iIndex);
extern void removeExif(char *filename, FILE *rfd);
extern long getMarkerOffset(FILE *rfd, unsigned short us_marker);
extern struct xmp_packet *chk_get_xmp_data(FILE *rfd);
extern struct xmp_data *xmp_display(const char * fileName, unsigned long length, char *data_ptr, bool bVerbos);
extern void create_root_index(char * filename);
extern void create_css(char * filename);
extern void create_gallery_index(char * filename, int iGalleryNumber);
extern void create_gallery_photos(char * filename, int iGalleryNumber);
extern void create_gallery(char *str_ptr);
extern void extract_thumbnail(char *filename, FILE *rfd);
extern void resize(char *file_src, char *file_dst, long width, long height, int jpeg_quality);
extern int jpegtran(int argc, char **argv);
extern void outputWeb();
extern char *getOrientation();
extern int getSOF0Data(FILE *rfd);
extern void replaceDescriptionValue(unsigned short usTag, int iType, char *localPtr);
extern void outputThumbnail(char *filename, FILE *rfd);
extern void outputThumbnailOld(char *filename, FILE *rfd);
extern string& getBaseName(char *filename);
extern string& getFileName(char *filename);
extern string& getFilePath(char *filename);
extern string& getDrive(char *filename);
extern void checkForWebConfig();
extern string& getWebConfigElement(const string& strElement);
extern void addToWebConfig(const string& strElement);
extern bool checkForJPGHeader(FILE *rfd);
extern string& getDataValueRaw(unsigned short usTag, int iTag, bool bMainList);
extern string& DecryptNikonData(string& strModel, string& strDataIn, string& strSerialNumber, string& strShutterCount, unsigned short usCount, unsigned short usOffset);
extern void restoreEXIF(char *filename, char *targetName);
extern string& getLocalTime();
extern void fixDate(char *filename, FILE *rfd);
extern void fixDateWithOffset(char *filename, FILE *rfd);
extern void checkForDateConfig();
extern IFDElement& getIFDObject(unsigned short usTag, bool bMainList);
extern int dcrawMain(char *filename, char *targetFile, int iFlip, bool bDoNotClipColor, bool bUseCameraWB, bool bUseAutoWB, bool bUseCameraRGB, float fBright, float fRed, float fBlue, int iMainBlack, bool bLocalTrace);
extern void outputJpegFine(char *filename);
extern int cjpegMain(int argc, char **argv);
extern bool isDirectoryFound(string& strInput);
extern string& IdentifyLensString( unsigned char byteB,
								   unsigned char byteC,
								   unsigned char byteD,
								   unsigned char byteE,
								   unsigned char byteF,
								   unsigned char byte10,
								   unsigned char byte11,
								   unsigned char lensType);
extern string& getTagValue(unsigned short usTag, int iType);
extern void QuickSortCString(vector<string>& vString, int left, int right, string& temp);
extern void getDOFData();
extern void renameImage(char *filename, FILE *rfd);
extern void removeTempDirectory();

#endif //_D70INC2_H
