/************************************************************************/
/*      $Id: d70reader.hpp,v 1.1 2005/05/10 20:17:46 joman Exp joman $    */
/*                                                                      */
/*      Include file name:   d70reader.hpp                              */
/*                                                                      */
/************************************************************************/
/*      Revisions:                                                      */
/*                                                                      */
/*      Version 0.01 - Tue May 10 14:47:38 EDT 2005:                    */
/*              First coding.                                           */
/************************************************************************/
#ifndef _D70READER_HPP
#define _D70READER_HPP

using namespace std;

#define LARGE_IMAGE_HEIGHT 532
#define LARGE_IMAGE_WIDTH 800
#define LARGE_IMAGE_LENGTH 800

int iWeb_First_Time = 1;
int iWeb_Image_count = 0;
int iRoot_Web_Image_count = 0;
int iWeb_Gallery_count = 0;
char *web_file_name_src_ptr = NULL;
char *web_file_name_tmp_ptr = NULL;
FILE *gallery_ofd = NULL;
FILE *root_ofd = NULL;
int iGlobalImageWidth = 0;
int iGlobalImageHeight = 0;
int	iSizeTestCompleted = 0;
char *str_root_temp_dir = NULL;
unsigned long lThumbnailOffset = 0l;
unsigned long lThumbnailLength = 0l;
char *GlobalOrientationPtr = NULL;

const int const iASCILabelSkipLength = 8;
const unsigned long const ulMakerNotePreHeaderLength = 10l;

bool bTrace = false;		// set this with -t option 
bool bVerbos = false;		// set this with -v option
bool bHtml = false;			// set this with -w option
bool bXml = false;			// set this with -x option
bool bThumbnail = false;	// set this with -j option
bool bThumbnailOld = false;	// set this with -jold option
bool bCsv = false;			// set this with -c option
bool bJS = false;			// set this with -js option
bool bWeb = false;			// set this with -web option
bool bRemoveEXIF = false;	// set this with -r option
bool bOutputPlain = true;	// turned off if certain switches are turned on

int iSystemType = 0;
int iImageType = -1;
int iFileType = -1;
unsigned long ulMakerNoteHeaderOffset = 0l;
int js_ctr1 = 0;

bool bCsvFirstTime = true;
bool bJSFirstTime = true;
bool bReverse = true;

long lFileSize = 0l;

struct image_file_header
{
    char byte_order[2];                     //byte order indicator 'II' or 'MM'
    unsigned short image_file_type;         //image file type                  
    unsigned long offset_to_first_ifd;      //offset to first IFD              
};

struct jpg_image_file_header
{
	unsigned char start;
	unsigned char soi;
	unsigned char pad;
	unsigned char exif_ind;
	unsigned short length;
	char exif_header_text[6];
	char byte_order[2];                     //byte order indicator 'II' or 'MM'
	unsigned short image_file_type;         //image file type                  
	unsigned long offset_to_first_ifd;      //offset to first IFD              
};

struct xmp_packet
{
	unsigned long length;
	char *value;
};

extern void instruct();
extern int imageType();
extern int fileTypeOffset();
extern int dumpImageFileDirectory(FILE *rfd, long offset, long additional_offset, std::string& strType, int numType);
extern bool isTagWanted(unsigned short usTag);
extern void ProcessFile(char *filename);
extern char *strip(char *str_input);
extern bool isTagYes(char *local_ptr);
extern void checkForConfig();
extern char *upperCase(char *local_ptr);
extern void outputPlain();
extern int my_mkdir(char *str_ptr);
extern int my_rmdir(char *str_ptr);
extern void my_error(FILE *rfd);
extern void my_fseek(FILE *rfd, long pos, int offset);
extern void my_exit(char *text_ptr);
extern void my_jpg_exit(char *text_ptr);
extern unsigned long getJpgTypeAndOffset(FILE *rfd, unsigned long offset);
extern unsigned long inspectImageFileHeader(FILE *rfd, int iType);
extern int fileTypeOffset();
extern string& getDataValue(unsigned short usTag, bool bMainList);
extern void outputHtml();
extern void outputXml();
extern void outputCsv();
extern void outputJs(FILE *ofd, bool bFirstTime, int iIndex);
extern void removeExif(char *filename, FILE *rfd);
extern long getMarkerOffset(FILE *rfd, unsigned short us_marker);
extern struct xmp_packet *chk_get_xmp_data(FILE *rfd);
extern struct xmp_data *xmp_display(const char * fileName, unsigned long length, char *data_ptr, bool bVerbos);
extern void create_root_index(char * filename);
extern void create_css(char * filename);
extern void create_gallery_index(char * filename, int iGalleryNumber);
extern void create_gallery_photos(char * filename, int iGalleryNumber);
extern void create_gallery(char *str_ptr);
extern void extract_thumbnail(char *filename, FILE *rfd);
extern void resize(char *file_src, char *file_dst, long width, long height, int jpeg_quality);
extern int jpegtran(int argc, char **argv);

#endif //_D70READER_HPP
