/************************************************************************/
/*      $Id: d70utils.cpp,v 1.2 2005/12/29 17:26:34 joman Exp joman $   */
/*                                                                      */
/*      Source file name:   d70utils.c                                  */
/*                                                                      */
/************************************************************************/
/*      Revisions:                                                      */
/*                                                                      */
/*      Version 0.01 - Mon Mar 21 17:16:56 EST 2005:                    */
/*              First coding.                                           */
/************************************************************************/

#ifdef WIN_GUI
#include "stdafx.h"
#endif

#include <sys/stat.h>

#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <string>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <list>

#ifdef WIN32
#include <direct.h>
#endif

#ifdef MPATROL_DEBUG
#include "mpatrol.h"
#endif

#include "D70Exception.h"

using namespace std;

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
int my_mkdir(char *str_ptr)
{
	int ret_code = 0;

#ifdef WIN32
	ret_code = _mkdir(str_ptr);
#else
	ret_code = mkdir(str_ptr, S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH);
#endif

	return(ret_code);
}

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
int my_rmdir(char *str_ptr)
{
	int ret_code = 0;

#ifdef WIN32
	ret_code = _rmdir(str_ptr);
#else
	ret_code = rmdir(str_ptr);
#endif

	return(ret_code);
}

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
void my_error(FILE *rfd)
{
	char buffer[16];

	if(ferror(rfd))
	{
		memset(buffer, '\0', 16);
		sprintf(buffer, "%d", fileno(rfd));
		string strTemp = string("\nError number: ") + string(buffer) + string("\n\n");
		ThrowD70Exception(strTemp);
	}
}

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
void my_fseek(FILE *rfd, long pos, int offset)
{
	long new_pos;

	if((new_pos = fseek(rfd, pos, offset)) != -1)
	{
		return;
	}
	else
	{
		my_error(rfd);
	}
}

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
void my_exit(char *text_ptr)
{
	string strTemp = string("\n\n") + 
					 string(text_ptr) + 
					 string("\n\nFile is not a JPG/JPEG file\n\n");

	ThrowD70Exception(strTemp);
}

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
void my_jpg_exit(char *text_ptr)
{
	string strTemp = string("\n\n") + 
					 string(text_ptr) + 
					 string("\n\nFile is not a NEF/RAW file\n\n");

	ThrowD70Exception(strTemp);
}

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
bool isDirectoryFound(string& strInput)
{
	bool bFind = false;
	struct stat buf;

	if(stat(strInput.c_str(), &buf) != (-1))
	{
		if(buf.st_mode &= _S_IFDIR)
			bFind = true;
	}

	return(bFind);
}
